unit rdbtool_MySQL;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls,
  Db, ADODb, Variants, Forms, DBGrids, MySQLDataset (or any name of UNIT containing TMySQLDataset);

procedure ChangeSortExMYSQL(MYSQL: TMySQLDataset; SortFieldNames: array of string; SortDirections: array of boolean; var Accept: boolean);

implementation

uses rstring, rtool, rdbtool, rdlg;

procedure ChangeSortExMYSQL(MYSQL: TMySQLDataset; SortFieldNames: array of string; SortDirections: array of boolean; var Accept: boolean);
const
  FieldSep = ',';
var
  B: TBookmark;
  F: TField;
  oldCursor: TCursor;
  i: integer;
  aFN, sFN: string;
begin
  // ArrOfStringToArrOfConst(SortFieldNames);
  oldCursor:=SQLCursor;
  try
    Accept:=MYSQL.Active and (not IsEditing(MYSQL));
    if not Accept then
      Abort;
    sFN:='';
    for i:=0 to High(SortFieldNames) do
    begin
      aFN:=SortFieldNames[i];
      F:=MYSQL.FindField(aFN);
      Accept:=Assigned(F) and IsSimpleField(F);
      if not Accept then
        Abort;
      if (F.FieldKind = fkLookup) then
        aFN:=F.KeyFields;
      if Pos(' ', aFN) > 0 then
        aFN:='"' + aFN + '"';
      if (i <= High(SortDirections)) and SortDirections[i] then
        aFN:=aFN + ' DESC';
      if sFN <> '' then
        sFN:=sFN + FieldSep;
      sFN:=sFN + aFN;
    end;
    B:=MYSQL.GetBookmark;
    try
      MYSQL.SortFieldNames :=sFN;
      MYSQL.GotoBookmark(B);
    finally
      MYSQL.FreeBookmark(B);
    end;
  except
    Accept:=false;
  end;
  ChCursor(oldCursor);
end;

end.